﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml.XPath;
using System.Xml;

namespace XML
{
    public partial class RSSReader : Form
    {
        public RSSReader()
        {
            InitializeComponent();
        }

        private void btnShow_Click(object sender, EventArgs e)
        {
            try
            {
                // Clear the treeview.
                tvwRss.Nodes.Clear();
                // set the wait cursor
                this.Cursor = Cursors.WaitCursor;
                // create a new xml doc
                XmlDocument doc = new XmlDocument();
                try
                {
                    // load the xml doc
                    doc.Load(txtRssAddress.Text);
                    // return the cursor
                    this.Cursor = Cursors.Default;
                }
                catch (Exception ex1)
                {
                    // return the cursor
                    this.Cursor = Cursors.Default;
                    // tell a story
                    MessageBox.Show(ex1.Message);
                    return;
                }

                // get an xpath navigator   
                XPathNavigator navigator = doc.CreateNavigator();
                try
                {
                    // look for the path to the rss item titles; navigate
                    // through the nodes to get all titles
                    XPathNodeIterator nodes = navigator.Select("//rss/channel/item/title");
                    while (nodes.MoveNext())
                    {
                        // clean up the text for display
                        XPathNavigator node = nodes.Current;
                        string tmp = node.Value.Trim();
                        tmp = tmp.Replace("\n", "");
                        tmp = tmp.Replace("\r", "");

                        // add a new treeview node for this
                        // news item title
                        tvwRss.Nodes.Add(tmp);
                    }

                    // set a position counter
                    int position = 0;
                    // Get the links from the RSS feed
                    XPathNodeIterator nodesLink = navigator.Select("//rss/channel/item/link");
                    while (nodesLink.MoveNext())
                    {
                        // clean up the link
                        XPathNavigator node = nodesLink.Current;
                        string tmp = node.Value.Trim();
                        tmp = tmp.Replace("\n", "");
                        tmp = tmp.Replace("\r", "");
                        // use the position counter
                        // to add a link child node
                        // to each news item title
                        tvwRss.Nodes[position].Nodes.Add(tmp);
                        // increment the position counter
                        position++;
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "RSS Feed Load Error");
                }
                // restore the cursor
                this.Cursor = Cursors.Default;
                tvwRss.ExpandAll();

            }
            catch (Exception ex2)
            {
                // snitch
                MessageBox.Show(ex2.ToString(), "RSS Feed Initialization Failure");
            }
        }

        private void tvwRss_AfterSelect(object sender, TreeViewEventArgs e)
        {
            try
            {
                // get the first four characters from the link
                string tmp = tvwRss.SelectedNode.Text.Substring(0, 4);

                // test the link text and then
                // navigate the browser to that link
                if (tmp == "http")
                    webBrowser1.Navigate(tvwRss.SelectedNode.Text);
            }
            catch
            {
                // if it is not a link, skip it
            }
        }
    }
}
