﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.IO;

namespace XML
{
    public partial class ReadXMLDataGridView : Form
    {
        public ReadXMLDataGridView()
        {
            InitializeComponent();
        }

        DataSet ds;
        string fdir;
        int rno = 0;
        DataRow dr;
        string Path = "";

        private void btnLoad_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "ostovarit.xml";
            openFileDialog1.Filter = "XML Files(ostovarit.xml)|ostovarit.xml";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                Path = openFileDialog1.FileName;
                ds = new DataSet();
                ds.ReadXml(Path);
                dataGridView1.DataSource = ds.Tables[0];
                ds.Tables[0].Constraints.Add("E-mail", ds.Tables[0].Columns[1], true);
                fdir = Path.Substring(0, Path.LastIndexOf("\\") + 1);
                if (dataGridView1.RowCount > 0)
                    this.dataGridView1.ClearSelection();
            }
        }

        private void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            showdata();
        }

        void showdata()
        {
            if (ds.Tables[0].Rows.Count > 0)
            {
                rno = dataGridView1.CurrentRow.Index;
                pictureBox1.Image = null;
                txtFullName.Text = ds.Tables[0].Rows[rno][0].ToString();
                txtEmail.Text = ds.Tables[0].Rows[rno][1].ToString();
                txtMob.Text = ds.Tables[0].Rows[rno][2].ToString();
                pictureBox1.ImageLocation = fdir + dataGridView1[3, dataGridView1.CurrentRow.Index].Value.ToString();
            }
            else
            {
                MessageBox.Show("No records. Create another XML file.");
                File.Delete(Application.StartupPath + "\\ostovarit.xml");
                ClearForm();
            }
        }

        private void btnInsert_Click(object sender, EventArgs e)
        {
            dr = null;
            dr = ds.Tables[0].Rows.Find(txtEmail.Text.Trim());
            if (dr == null)
            {
                dr = ds.Tables[0].NewRow();
                dr[0] = txtFullName.Text.Trim();
                dr[1] = txtEmail.Text.Trim();
                dr[2] = txtMob.Text.Trim();
                dr[3] = txtEmail.Text.Trim() + ".jpg";
                phototask();
                ds.Tables[0].Rows.Add(dr);
                dataGridView1.DataSource = ds.Tables[0];
                ds.WriteXml(Path);
            }
            else
                MessageBox.Show("Insert another Email address", "Error", MessageBoxButtons.OK,MessageBoxIcon.Error);
        }

        void phototask()
        {
            //finding name of photo ,saving it in directory of xml file with unique name(Email+photo name)
            string pdestin = Application.StartupPath + "\\" + txtEmail.Text.Trim() + ".jpg ";
            pictureBox1.Image.Save(pdestin);//saving photo on disk
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            openFileDialog2.FileName = "";
            openFileDialog2.Filter = "Image Files(*.jpg)|*.jpg";
            if (openFileDialog2.ShowDialog() == DialogResult.OK)
                pictureBox1.ImageLocation = openFileDialog2.FileName;
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            DataRow drow = ds.Tables[0].Rows.Find(dataGridView1[1,dataGridView1.CurrentRow.Index].Value.ToString());
            if (drow != null)
            {
                rno = ds.Tables[0].Rows.IndexOf(drow);

                ds.Tables[0].Rows[rno][0] = txtFullName.Text;
                ds.Tables[0].Rows[rno][1] = txtEmail.Text;
                ds.Tables[0].Rows[rno][2] = txtMob.Text;
                phototask();
                ds.Tables[0].Rows[rno][3] = txtEmail.Text.Trim() + ".jpg";
                ds.WriteXml(Path);
                MessageBox.Show("record updated");
            }
            else
                MessageBox.Show("no record exists with this Email.");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ClearForm();
        }

        public void ClearForm()
        {
            txtEmail.Text = string.Empty;
            txtFullName.Text = string.Empty;
            txtMob.Text = string.Empty;

            if (dataGridView1.RowCount > 0)
                this.dataGridView1.ClearSelection();
            pictureBox1.Image = null;
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedRows.Count > 0)
            {
                DataRow drow = ds.Tables[0].Rows.Find(dataGridView1[1, dataGridView1.CurrentRow.Index].Value.ToString());
                if (drow != null)
                {
                    File.Delete(Application.StartupPath + "\\" + dataGridView1[3, dataGridView1.CurrentRow.Index].Value.ToString());
                    ds.Tables[0].Rows.Remove(drow);
                    ds.WriteXml(Path);
                    MessageBox.Show("record deleted.");
                    showdata();
                }
                else
                    MessageBox.Show("no record exists with this Email.");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            CreateXMLsimple cxs = new CreateXMLsimple();
            cxs.Show(this);
        }
    }
}
