﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Collections;

namespace XML
{
    public partial class ReadXMLListBox : Form
    {
        public ReadXMLListBox()
        {
            InitializeComponent();
        }

        private void ReadXMLTreeView2_Load(object sender, EventArgs e)
        {
            // where do we want to get the XML from...
            String filename = Application.StartupPath + "\\sampleMail.xml";
            txtRoot.Text = filename;
            // open the document...
            XmlTextReader reader = new XmlTextReader(filename);
            // move to the start of the document...
            reader.MoveToContent();
            // start working through the document...
            Hashtable addressData = null;
            String elementName = null;
            while (reader.Read())
            {
                // what kind of node to we have?
                switch (reader.NodeType)
                {
                    // is it the start of an element?
                    case XmlNodeType.Element:
                        // if it’s an element start, is it “Address”?
                        if (reader.Name == "Address")
                            // if so, create a new collection...
                            addressData = new Hashtable();
                        else
                            // if not, record the name of the element...
                            elementName = reader.Name;
                        break;
                    // if we have some text, try storing it in the
                    // collection...
                    case XmlNodeType.Text:
                        // do we have an address?
                        if (addressData != null)
                            addressData.Add(elementName,reader.Value);
                        break;
                    // is it the end of an element?
                    case XmlNodeType.EndElement:
                        // if it is,
                        // we should have an entire address stored...
                        if (reader.Name == "Address")
                        {
                            // try to create a new listview item...
                            String item = null;
                            try
                            {
                                item = addressData["FirstName"] +
                                " " + addressData["LastName"]
                                + " (" +

                                addressData["Email"] + ")";
                            }
                            catch
                            {
                            }
                            // add the item to the list...
                            lstEmails.Items.Add(item);
                            // reset...
                            addressData = null;
                        }
                        break;
                }
            }
        }
    }
}
