﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace XML
{
    public partial class ReadXMLTreeView : Form
    {
        public ReadXMLTreeView()
        {
            InitializeComponent();
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = ".xml";
            openFileDialog1.Filter = "XML Files(*.xml)|*.xml";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                txtRoot.Text = openFileDialog1.FileName;
                updateTreeView(txtRoot.Text);
            }
        }

        private void updateTreeView(string filename)
        {
            try
            {
                treeView1.Nodes.Clear();
                XmlDocument tmpxmldoc = new XmlDocument();
                tmpxmldoc.Load(filename);
                FillTree(tmpxmldoc.DocumentElement, treeView1.Nodes);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void FillTree(XmlNode node, TreeNodeCollection NodeCollection)
        {
            if (node == null || node.NodeType == XmlNodeType.Text || node.NodeType == XmlNodeType.CDATA)
                return;

            TreeNodeCollection treenodecollection = AddNodeToTree(node, NodeCollection);
            foreach (XmlNode tmpchildnode in node.ChildNodes)
            {
                FillTree(tmpchildnode, treenodecollection);
            }
        }

        private TreeNodeCollection AddNodeToTree(XmlNode node, TreeNodeCollection NodeCollection)
        {
            TreeNode newchildnode = CreateTreeNodeFromXmlNode(node);
            if (newchildnode == null)
                return NodeCollection;
            if (NodeCollection != null)
                NodeCollection.Add(newchildnode);

            return newchildnode.Nodes;
        }

        private TreeNode CreateTreeNodeFromXmlNode(XmlNode node)
        {
            TreeNode tmptreenode = new TreeNode();
            if ((node.HasChildNodes) && (node.FirstChild.Value != null))
            {
                tmptreenode = new TreeNode(node.Name);
                TreeNode tmptreenode2 = new TreeNode(node.FirstChild.Value);
                tmptreenode.Nodes.Add(tmptreenode2);
            }
            else if (node.NodeType != XmlNodeType.CDATA)
            {
                tmptreenode = new TreeNode(node.Name);
            }
            return tmptreenode;
        }
    }
}
