﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace XML
{
    public partial class ReadXMLtxtBox : Form
    {
        public ReadXMLtxtBox()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            txtXMLValues.Text = "";
            openFileDialog1.FileName = ".xml";
            openFileDialog1.Filter = "XML Files(*.xml)|*.xml";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
                txtRoot.Text = openFileDialog1.FileName;
            
            XmlTextReader reader = new XmlTextReader(txtRoot.Text);
            while (reader.Read())
            {
                switch (reader.NodeType)
                {
                    case XmlNodeType.Element: // The node is an element.
                        txtXMLValues.Text = txtXMLValues.Text + "<" + reader.Name;
                        while (reader.MoveToNextAttribute())
                        {
                            // Read the attributes.
                            txtXMLValues.Text = txtXMLValues.Text +" " + reader.Name + "='" + reader.Value + "'";
                        }
                        txtXMLValues.Text = txtXMLValues.Text + ">\n";
                        break;
                    case XmlNodeType.Text: //Display the text in each element.
                        txtXMLValues.Text = txtXMLValues.Text + "     " + reader.Value + "\n";
                        break;
                    case XmlNodeType.EndElement: //Display the end of the element.
                        txtXMLValues.Text = txtXMLValues.Text + "</" + reader.Name + ">\n";
                        break;
                }
            }
        }

        private void ReadXMLtxtBox_Load(object sender, EventArgs e)
        {

        }
    }
}
