﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml.Serialization;

namespace XML
{
    public class SerializableData
    {
        public void Save(String filename, Type newType)
        {
            // make a temporary filename...
            String tempFilename;
            tempFilename = filename + ".tmp";
            // does the file exist?
            FileInfo tempFileInfo = new FileInfo(tempFilename);
            if (tempFileInfo.Exists)
                tempFileInfo.Delete();
            // open the file...
            FileStream stream = new FileStream(tempFilename,
            FileMode.Create);
            // save the object...
            Save(stream, newType);
            // close the file...
            stream.Close();
            // remove the existing data file and
            // rename the temp file...
            tempFileInfo.CopyTo(filename, true);
            tempFileInfo.Delete();
        }
        // Save - actually perform the serialization...
        public void Save(Stream stream, Type newType)
        {
            // create a serializer...
            XmlSerializer serializer = new XmlSerializer(newType);
            // save the file...
            serializer.Serialize(stream, this);
        }


        public static Object Load(String filename, Type newType)
        {
            // does the file exist?
            FileInfo fileInfo = new FileInfo(filename);
            if (!fileInfo.Exists)
            {
                // create a blank version of the object and return that...
                return System.Activator.CreateInstance(newType);
            }
            // open the file...
            FileStream stream = new FileStream(filename, FileMode.Open);
            // load the object from the stream...
            Object newObject = Load(stream, newType);
            // close the stream...
            stream.Close();
            // return the object...
            return newObject;
        }
        public static Object Load(Stream stream, Type newType)
        {
            // create a serializer and load the object....
            XmlSerializer serializer = new XmlSerializer(newType);
            Object newObject = serializer.Deserialize(stream);
            // return the new object...
            return newObject;
        }
    }
}
