﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;        // for XmlTextReader and XmlValidatingReader
using System.Xml.Schema; // for XmlSchemaCollection (which is used later)


namespace XML
{
    public partial class XmlValidatingReaderSample : Form
    {
        public XmlValidatingReaderSample()
        {
            InitializeComponent();
        }

        public static bool isValid;
        public static string error;

        private void XmlSchemaValidationSample_Load(object sender, EventArgs e)
        {
            txtValidFile.Text = Application.StartupPath + "\\ProductWithXsd.xml";
            txtInvalidFile.Text = Application.StartupPath + "\\Product.xml";
        }

        public void ValidateXML(string filename)
        {
            isValid = true;
            error = "";
            try
            {
                XmlTextReader xml = new XmlTextReader(filename);
                XmlValidatingReader xsd = new XmlValidatingReader(xml);
                //Validation Type
                if (radioButton1.Checked)
                    xsd.ValidationType = ValidationType.Schema;
                else if (radioButton2.Checked)
                    xsd.ValidationType = ValidationType.DTD;
                else
                    xsd.ValidationType = ValidationType.None;
                //and validation errors events go to...
                xsd.ValidationEventHandler += new ValidationEventHandler(MyValidationEventHandler);
                //wait until the read is over, its occuring in a different thread - kinda like when your walking to get a cup of coffee and your mind is in Hawaii
                while (xsd.Read())
                {
                }
                xsd.Close();
                // Check whether the document is valid or invalid.
                if (isValid)
                    MessageBox.Show("Document is valid");
                else
                    MessageBox.Show("Document is invalid");
            }
            catch (UnauthorizedAccessException a)
            {
                //dont have access permission
                error = a.Message;
            }
            catch (Exception a)
            {
                //and other things that could go wrong
                error = a.Message;
            }
            resultErrors.Text = error;
        }

        //handle our validation errors
        public static void MyValidationEventHandler(object sender,ValidationEventArgs args)
        {
            isValid = false;
            error += args.Message + "\n\n";
        }

        private void btnValidate1_Click(object sender, EventArgs e)
        {
            ValidateXML(txtValidFile.Text);
        }

        private void btnValidate2_Click(object sender, EventArgs e)
        {
            ValidateXML(txtInvalidFile.Text);
        }

    }

}
